"""
配置文件
"""
import os
class Config:
    # 配置MySQL参数
    MYSQL_DIALECT = 'mysql'
    MYSQL_DIRVER = 'pymysql'
    MYSQL_NAME = 'root'
    MYSQL_PWD = 'root'
    MYSQL_HOST = 'localhost'
    MYSQL_PORT = 3306
    MYSQL_DB = 'flask_shop'
    MYSQL_CHARSET ='utf8mb4'

    SQLALCHEMY_DATABASE_URI = f'{MYSQL_DIALECT}+{MYSQL_DIRVER}://{MYSQL_NAME}:{MYSQL_PWD}@{MYSQL_HOST}:{MYSQL_PORT}/{MYSQL_DB}?charset={MYSQL_CHARSET}'
    SQLALCHEMY_TRACK_MODIFICATIONS = True
    SECRET_KEY = os.urandom(16)

    # 设置上传图片允许的类型
    ALLOWED_IMG = set(['bmp', 'png', 'jpg', 'jpeg', 'gif'])

    # 上传的图片储存的位置
    # 获取当前项目的dir
    """
    os.path.abspath(__path): 获取当前文件的上一级目录
    """
    BASE_DIR = os.path.dirname(os.path.abspath(__file__))
    
    # 设置当前服务器的upload（上传）图片的地址
    """
    os.path.join() :拼接地址
    """
    SEVER_IMG_UPLOADS = os.path.join(BASE_DIR, 'flask_shop', 'static', 'img') 


# 开发模式 继承Config的配置信息
class DevelopmentConfig(Config):
    DEBUG = True

# 生产模式 继承Config的配置信息
class ProductionConfig(Config):
    pass

# 方便传参数
config_map = {
    "development": DevelopmentConfig,
    "production": ProductionConfig
}