"""
菜单蓝图
"""
from flask_shop.menu import menu_bp, menu_api
from flask_shop import models
from flask import request
from flask_restful import Resource
from flask_shop.utils.message import state_message


class Menu(Resource):
    def get(self):
        type_ = request.args.get('type')
        menu_list = []
        if type_ == 'list':
            # 获取数据，并将数据填充到menu_list里面
            mu = models.Menu.query.filter(models.Menu.level != 0).all()
            for m in mu:
                # print(m)
                menu_list.append(m.to_dict())
                # print(m.children)
        else:
            # 获取的是树形结构的数据
            mu = models.Menu.query.filter(models.Menu.level == 1).all()
            for m in mu:
                # print(m)
                # 获取一级菜单转成JSON
                first_mu = m.to_dict()
                # print(first_mu)
                # 给二级菜单创建保存容器
                first_mu['children'] = []
                for sm in m.children:
                    # print(sm)
                    # 获取二级菜单并转成JSON
                    secd_dict = sm.to_dict()
                    # print(secd_dict)
                    # 给三级菜单创建保存容器,并把三级菜单数据加进来
                    secd_dict['children'] = sm.get_child_list()
                    # 把二级菜单添加到一级菜单的children列表中
                    first_mu['children'].append(secd_dict)
                # 把一级菜单添加到根列表中
                menu_list.append(first_mu)
        return state_message(200, data=menu_list)

# 添加类视图和url
menu_api.add_resource(Menu, '/meun')